设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 214|回复: 3

[已解决] 这种线的连接 方法

[复制链接]

已领礼包: 16个

财富等级: 恭喜发财

发表于 2019-8-26 20:33:53 | 显示全部楼层 |阅读模式
20D豆
本帖最后由 xdzcp 于 2019-8-29 21:03 编辑

QQ图片20190816083215.png 框选全部上面的白色线条自动生成红色线条,并自动连接。谢谢

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 372个

财富等级: 日进斗金

发表于 2019-8-27 08:20:54 | 显示全部楼层
本帖最后由 pxr201419 于 2019-8-27 08:36 编辑

(defun c:jj()    (vl-load-com)
    (prompt "选择线条:")
    (setq ss (ssget ":s" '((0 . "*LINE"))) ii 0 ptlst nil ptlst1 nil)
    (while (ssname ss ii)
        (setq en (ssname ss ii)
              pt1 (vlax-curve-getstartpoint en)
              pt2 (vlax-curve-getendpoint en)
              ptlst (append ptlst (list pt1 pt2))
              ii (1+ ii)))
    (setq e1 (entsel "选择第1根线的起始端:")
          p1 (cadr e1)
          e1 (car e1)
          p01 (vlax-curve-getstartpoint e1)
          p02 (vlax-curve-getendpoint e1)
          s1 (distance p1 p01)
          s2 (distance p1 p02))
    (if (> s1 s2)(setq p2 p02)(setq p2 p01))
    (while ptlst
        (setq slst (mapcar '(lambda (x) (distance p2 x)) ptlst))
        (setq n1 (car (vl-sort-i slst '<))
              n2 (fix (/ n1 2)))
        (setq p1 (nth n1 ptlst))
        (if (= n1 (* n2 2))
            (setq p2 (nth (1+ n1) ptlst))
            (setq p2 (nth (1- n1) ptlst))        )
        (setq ptlst (vl-remove p1 ptlst)
              ptlst (vl-remove p2 ptlst))
        (setq ptlst1 (append ptlst1 (list p1) (list p2)))
    )
    (entmake (append (list '(0 . "LWPOLYLINE")'(100 . "AcDbEntity")'(100 . "AcDbPolyline")(cons 90 (length ptlst1)))
                     (mapcar '(lambda (x)(cons 10 (reverse(cdr(reverse x))))) ptlst1))
    )
    (setq ii 0)
    (while (ssname ss ii)(entdel (ssname ss ii))(setq ii (1+ ii)))
    )

JJ.gif

点评

谢谢大神 解决了每次都要连接连接 再连接  详情 回复 发表于 2019-8-29 20:46
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 16个

财富等级: 恭喜发财

 楼主| 发表于 2019-8-29 20:46:11 | 显示全部楼层
pxr201419 发表于 2019-8-27 08:20
(defun c:jj()    (vl-load-com)
    (prompt "选择线条:")
    (setq ss (ssget ":s" '((0 . "*LINE"))) ...

谢谢大神 解决了每次都要连接连接 再连接
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

发表于 2019-9-22 19:05:47 来自手机 | 显示全部楼层
太强大了!
来自: 微社区
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-8-6 21:10 , Processed in 0.085505 second(s), 43 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表